/*

 Definitions.H - Main 128Gamma Variable Definition File

*/

//--------------------------------------------------------------------

#if defined(__cplusplus)
#error 128Gamma was designed to be compiled using C not C++.
#endif

#define TitleCaption "128Gamma Encryption"
#define GammaVersion "Version 2.0 - Revision C"

#define ENCFlag "Secure128~"
#define PACFlag "Packed128~"

#define VersionInfo 10000
#define BufferSize 512

#include "Headers/Registry.H"

//--------------------------------------------------------------------
		/* Thread Handles, ID's And Prototypes*/ // Begin

extern DWORD WINAPI EncryptProcess_Thread(LPVOID);
HANDLE EncryptProcess_Thread_Handle;
long EncryptProcess_Thread_ID;

extern DWORD WINAPI DecryptProcess_Thread(LPVOID);
HANDLE DecryptProcess_Thread_Handle;
long DecryptProcess_Thread_ID;

extern DWORD WINAPI StatusDialog_Thread(LPVOID );
HANDLE StatusDialog_Thread_Handle;
long StatusDialog_Thread_ID;

extern DWORD WINAPI UnpackProcess_Thread(LPVOID);
HANDLE UnpackProcess_Thread_Handle;
long UnpackProcess_Thread_ID;

extern DWORD WINAPI PackProcess_Thread(LPVOID);
HANDLE PackProcess_Thread_Handle;
long PackProcess_Thread_ID;

		/* Thread Handles, ID's And Prototypes*/ // End
//--------------------------------------------------------------------
		/* Various Function Prototypes */ // Begin

extern void SetText (HWND, char *);
extern void CenterWindow (HWND);
extern void Error(char *);
extern void ClearBuffer(void);
extern void Update_LastUsed(void);

extern char *GetText (HWND);
extern char *GetTempDirectory(void);
extern char *CipherKey(char []);
extern char *Get_Time (void);
extern char *Get_LongDate (void);
extern char *Get_UserName (void);

extern int WINAPI WinMain(HWND , HWND , LPSTR , int );
extern int PasswordDialog (HWND, int , int , int );
extern int AboutDialog (HWND, int , int , int );
extern int StatusDialog (HWND , int , int , int );
extern int WriteFiles(char *, short, char *, char *, int);
extern int Get_NumberOfFiles(char []);
extern int PackFiles(char *,char *);
extern int UnPackFiles(char *,char *);

extern int Cipher(char *, char *, char *);
extern int Decipher(char *, char *, char *);
extern int IncodeMain(char *, char *);
extern int DecodeMain(char *, char *);

extern int EncryptProcess(void);
extern int DecryptProcess(void);
extern int PackProcess(void);
extern int UnpackProcess(void);

extern int ProcessInput(char *);
extern int CancelProcess(void);
extern int Backup(void);

extern int CharInt (char *);
extern int CleanUp(int, int);
extern int Encrypted(char *);
extern int SetTempVariables(void);

extern BOOL FAccess(char *, short);
extern DWORD FileSize(char *);

		/* Various Function Prototypes */ // End
//--------------------------------------------------------------------
		/* Various Global Variables */ // Begin

char EncryptTemp[257];
char PackTemp[257];
char BackupTemp[257];
char GlobalFileName[256];
char Password[75];
char Directory[257];
char Buffer[BufferSize];
char *Status;
char *CodedKey;

int End_Of_File = 0;

long double StatusValue = 0;

		/* Various Global Variables */ // End
//--------------------------------------------------------------------
		/* Various Windows Handles */ // Begin

static HWND hInstance = 0;
static HWND PasswordDialog_hWnd = 0;
static HWND AboutDialog_hWnd = 0;
static HWND StatusDialog_hWnd = 0;

		/* Various Windows Handles */ // End
//--------------------------------------------------------------------
		/* Global Variables Used As Flags (BOOL) */ // Begin


BOOL Encrypt = 0;
BOOL Decrypt = 0;
BOOL Unpack = 0;
BOOL Pack = 0;

BOOL CancelFlag = 0;
BOOL Verifiy = 0;
BOOL DoneFlag = 0;
BOOL KillFlag = 0;

		/* Global Variables Used As Flags */ // End
//--------------------------------------------------------------------


