/*
 Functions.H - Main 128Gamma Functions File

extern void Error(char *Message)
extern int CleanUp(int Kill, int Delete)
extern int Encrypted(char *FileToCheck)
extern int SetTempVariables(void)
extern int CharInt(char *string2convert)
extern char *GetTempDirectory(void)
extern int Get_NumberOfFiles(char CountFileTemp[257])
extern void SetText (HWND hDlg, char *Txt)
extern char *GetText (HWND hDlg)
extern void CenterWindow (HWND hWnd)
extern int EncryptProcess(void)
extern int DecryptProcess(void)
extern int PackProcess(void)
extern int UnpackProcess(void)
extern int ProcessInput(char *xInput)
extern int CancelProcess(void)
extern int Backup(void)
extern DWORD FileSize(char *File2Size)
extern void ClearBuffer(void)
extern DWORD WINAPI StatusDialog_Thread(LPVOID data)
extern DWORD WINAPI EncryptProcess_Thread(LPVOID data)
extern DWORD WINAPI DecryptProcess_Thread(LPVOID data)
extern DWORD WINAPI PackProcess_Thread(LPVOID data)
extern DWORD WINAPI UnpackProcess_Thread(LPVOID data)
extern BOOL FAccess(char *FileName, short Mode)
extern char *Get_Time(void)
extern char *Get_LongDate(void)
extern char *Get_UserName(void)
extern void Update_LastUsed(void)

*/

//--------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////

extern void Error(char *Message)
{
	KillFlag = 1;
	MessageBox (GetActiveWindow(), Message ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
	CleanUp(1,1);
}

//////////////////////////////////////////////////////////////////////

extern int CleanUp(int Kill, int Delete)
{
	if(Delete)
	{
		_fcloseall(); //Attempt To Close All Open Files... (If Any)
		unlink(EncryptTemp);
		unlink(PackTemp);
		unlink(BackupTemp);
	}

	if(Kill)
	{
		_fcloseall(); //Attempt To Close All Open Files... (If Any)
		sleep(500); // Hopfully Give Time For Files To Reset Or Flush.
		unlink(EncryptTemp);
		unlink(PackTemp);
		unlink(BackupTemp);
		exit(0);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int Encrypted(char *FileToCheck)
{
	FILE * FileToCheck_File;

	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL)
		Error("Could Not Open Source For Read. Error: 14.");

	fread(Buffer,sizeof(char),10,FileToCheck_File);

	if(strcmp(Buffer,ENCFlag) == 0)
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		End_Of_File = 0;
		return 1;
	}

	if(strcmp(Buffer,PACFlag) == 0)
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		End_Of_File = 0;
		return 2;
	}

	if(FileToCheck_File)
		fclose(FileToCheck_File);
	return 3;
}

//////////////////////////////////////////////////////////////////////

extern int SetTempVariables(void)
{
	sprintf(EncryptTemp,"%s\\%s",GetTempDirectory(),"Encrypt.128G");
	sprintf(PackTemp,"%s\\%s",GetTempDirectory(),"Pack.128G");
	sprintf(BackupTemp,"%s\\%s",GetTempDirectory(),"Backup.128G");
	if(!BackupTemp)
		return 1;
	if(!EncryptTemp)
		return 1;
	if(!PackTemp)
		return 1;
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int CharInt(char *string2convert)
{
	int i, lenght_string;
	int power;
	int tmp_number;
	char tmp_char;
	if (!string2convert)
	{
		string2convert = "0";
		Error("Character To Interger Conversion Error. Error: 15.");
		return -1;
	}
	lenght_string = strlen(string2convert);
	for(i = 0; i < (lenght_string / 2); i++)
	{
		tmp_char = string2convert[i];
		string2convert[i] = string2convert[lenght_string - 1 - i];
		string2convert[lenght_string - 1 - i] = tmp_char;
	}
	power = 1;
	i = 0;
	tmp_number = 0;
	while (string2convert[i] != '\0')
	{
		tmp_number += (string2convert[i] - '0') * power;
		power *= 10;
		i++;
	}
	return tmp_number;
}

/////////////////////////////////////////////////////////////////////

extern char *GetTempDirectory(void)
{
	static char StrFunction [64][257] = {'\0'};
	int StrCnt = 0;
	char T[257] = {'\0'};
	GetTempPath (256,T);
	if (++StrCnt==64) StrCnt = 0;
	sprintf(StrFunction[StrCnt],"%s",T);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern int Get_NumberOfFiles(char CountFileTemp[257])
{
	int Number_Of_Files = 0;
	int LocalPlaceHolder = 0;

	while(1)
	{
		while(CountFileTemp[LocalPlaceHolder] != '\0')
		{
			LocalPlaceHolder++;
		}
		LocalPlaceHolder++;
		if(CountFileTemp[LocalPlaceHolder] == '\0')break;
		Number_Of_Files++;
	}
	return Number_Of_Files;
}

///////////////////////////////////////////////////////////////////////

extern void SetText (HWND hDlg, char *Txt)
{
	SendMessage(hDlg,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)Txt);
}

/////////////////////////////////////////////////////////////////////

extern char *GetText (HWND hDlg)
{
	short LocalLoop = 0;
	int StrCnt = 0;
	int T = 0;
	char xBuffer[2048] = {'\0'};
	LPSTR StrFunc[16] = {'\0'};

	while(LocalLoop < 16)
	{
		StrFunc[LocalLoop] = '\0';
		LocalLoop++;
	}
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	T=GetWindowTextLength(hDlg);
	GetWindowText(hDlg,xBuffer,T+1);
	sprintf(StrFunc[StrCnt],"%s",xBuffer);
	return StrFunc[StrCnt];
}
/////////////////////////////////////////////////////////////////////

extern void CenterWindow (HWND hWnd)
{
	static RECT wRect;
	DWORD x = 0;
	DWORD y = 0;
	GetWindowRect(hWnd,&wRect);
	x=(GetSystemMetrics(SM_CXSCREEN)-(wRect.right-wRect.left))/2;
	y=(GetSystemMetrics(SM_CYSCREEN)-(wRect.bottom-wRect.top+GetSystemMetrics(SM_CYCAPTION)))/2;
	SetWindowPos(hWnd,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////

extern int EncryptProcess(void)
{
	CleanUp(0,1);

	if(Backup())
	{
		Status = "Backup Failed...";
		DoneFlag = 1;
		CleanUp(0,1);
		return(0);
	}

	Status = "Ciphering...";
	/* EnCode(Source,Target,Password); */
	if(Cipher(GlobalFileName,EncryptTemp,CodedKey))
	{
		Status = "Encoding...";
		/* IncodeMain(Source,Target); */
		if(IncodeMain(EncryptTemp,GlobalFileName))
		{
			Status = "Data Successfully Encrypted!";
		}

	}

	CleanUp(0,1);
	DoneFlag = 1;
	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int DecryptProcess(void)
{
	CleanUp(0,1);

	if(Backup())
	{
		Status = "Backup Failed...";
		DoneFlag = 1;
		CleanUp(0,1);
		return(0);
	}

	Status = "Decoding...";
	if(DecodeMain(GlobalFileName,EncryptTemp))
	{
		Status = "Deciphering...";
		if(Decipher(EncryptTemp,GlobalFileName,CodedKey))
		{
			Status = "Data Successfully Decrypted!";
		}
	}

	CleanUp(0,1);
	DoneFlag = 1;

	return(0);
}

//////////////////////////////////////////////////////////////////////

extern int PackProcess(void)
{
	CleanUp(0,1);

	if(PackFiles(GlobalFileName,Directory))
	{
		ShowWindow(StatusDialog_hWnd,TRUE);

		Status = "Ciphering...";
		/* EnCode(Source,Target,Password); */
		if(Cipher(GlobalFileName,EncryptTemp,CodedKey))
		{
			Status = "Encoding...";
			/* IncodeMain(Source,Target); */
			if(IncodeMain(EncryptTemp,GlobalFileName))
			{
				Status = "Files Successfully Packed!";
			}
		}
	}

	DoneFlag = 1;
	CleanUp(0,1);

	return(0);
}

//////////////////////////////////////////////////////////////////////

extern int UnpackProcess(void)
{
	CleanUp(0,1);

	char xPath[257];
	char xDrive[11];

	xPath[0] = '\0';
	xDrive[0] = '\0';

	char SourceFilePath[257];
	/* Split Drive And Path Of SourceFileName And Set Then To (SourceFilePath) */

	_splitpath(GlobalFileName,xDrive,xPath,NULL,NULL);
	sprintf(SourceFilePath,"%s%s",xDrive,xPath);

	Status = "Decoding...";
	if(DecodeMain(GlobalFileName,EncryptTemp))
	{
		Status = "Deciphering...";
		if(Decipher(EncryptTemp,PackTemp,CodedKey))
		{
			if(UnPackFiles(PackTemp,SourceFilePath))
			{
				Status = "Files Successfully UnPacked!";
				CleanUp(0,1);
			}
		}
	}

	DoneFlag = 1;
	CleanUp(0,1);

	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int ProcessInput(char *xInput)
{
	short ENCMethod;
	ENCMethod = 0;
	long double SourceFileSize = 0;

	if(strlen(xInput) > 0) // If Any Program Input Params
	{
		char Extention[27];
		char xDrive[7];
		char xPath[257];

		if(!FAccess(xInput,0))
			Error("File Does Not Exist.");
		if(!FAccess(xInput,2))
			Error("File Does Not Allow Write Access.");
		if(!FAccess(xInput,4))
			Error("File Does Not Allow Read Access.");
		if(!FAccess(xInput,6))
			Error("File Does Not Allow Read Or Write Access.");

		_splitpath(xInput,xDrive,xPath,NULL,Extention);

		sprintf(GlobalFileName,"%s",xInput);

		/* Empty And Extention Is .128 */
		if( (FileSize(xInput) == 0) && (strcmp(Extention,".128") == 0) )
		{
			sprintf(Directory,"%s%s",xDrive,xPath);
			Pack = 1;
			Decrypt = 0;
			Encrypt = 0;
			Unpack = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}
		if(SourceFileSize == -1)
		{
			Error("File Size Error. Error 16.");
			DoneFlag = 1;
			CleanUp(0,1);
			return(0);
		}

		/* ENCMethod ( 1 = Encrypted , 2 = Packed , 3 = NOT Encrypted) */

		ENCMethod = Encrypted(GlobalFileName);

		if(ENCMethod == 1) // Encrypted
		{
			Decrypt = 1;
			Encrypt = 0;
			Unpack = 0;
			Pack = 0;

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 2) //  Packed
		{
			Unpack = 1;
			Decrypt = 0;
			Encrypt = 0;
			Pack = 0;

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 3) // NOT Encrypted
		{
			Encrypt = 1;
			Unpack = 0;
			Decrypt = 0;
			Pack = 0;

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}
	}

	CleanUp(0,1);

	return 1;
}

/////////////////////////////////////////////////////////////////////

extern int CancelProcess(void)
{
	if(Pack || Unpack)return 0;

	Status = "Restoring Source File.";
	long double SourceFileSize = 0;
	long double Current_Size = 0;
	int SentSize = 0;
	FILE *Source, *Target;

	SourceFileSize = FileSize(BackupTemp);
	if(SourceFileSize == -1)
	{
		Error("File Size Error. Error 17.");
		DoneFlag = 1;
		CleanUp(0,1);
		return(0);
	}

	if((Source = fopen(BackupTemp,"rb")) == NULL)
	{
		if(Source)fclose(Source);
		return 0;
	}

	if((Target = fopen(GlobalFileName,"wb")) == NULL)
	{
		if(Source)fclose(Source);
		if(Target)fclose(Target);
		unlink(BackupTemp);
		return 0;
	}

	do
	{
		SentSize = fread(Buffer,sizeof(char),BufferSize,Source);
		fwrite(Buffer,sizeof(char),SentSize,Target);

		Current_Size += SentSize;
		StatusValue = (Current_Size / SourceFileSize) * 100;

	}
	while(SentSize == BufferSize);

	if(Source)fclose(Source);
	if(Target)fclose(Target);

	return 0;
}

/////////////////////////////////////////////////////////////////////

extern int Backup(void)
{
	long double SourceFileSize = 0;
	long double Current_Size = 0;
	int SentSize = 0;
	FILE *Source, *Target;
	Status = "Backing Up Source File.";
	SourceFileSize = FileSize(GlobalFileName);
	if(SourceFileSize == -1)
	{
		Error("File Size Error. Error 18.");
		DoneFlag = 1;
		CleanUp(0,1);
		return(0);
	}

	if((Source = fopen(GlobalFileName,"rb")) == NULL)
	{
		if(Source)fclose(Source);
		return 0;
	}

	if((Target = fopen(BackupTemp,"wb")) == NULL)
	{
		if(Source)fclose(Source);
		if(Target)fclose(Target);
		unlink(BackupTemp);
		return 0;
	}

	do
	{
		if(CancelFlag)
		{
			if(Source)fclose(Source);
			if(Target)fclose(Target);
			unlink(BackupTemp);
			CleanUp(0,1);
			return 0;
		}

		SentSize = fread(Buffer,sizeof(char),BufferSize,Source);
		fwrite(Buffer,sizeof(char),SentSize,Target);

		Current_Size += SentSize;
		StatusValue = (Current_Size / SourceFileSize) * 100;
	}
	while(SentSize == BufferSize);

	if(Source)fclose(Source);
	if(Target)fclose(Target);
	return 0;
}

/////////////////////////////////////////////////////////////////////

extern DWORD FileSize(char *File2Size)
{
	FILE *Source;
	DWORD size;
	SetFileAttributes(File2Size,FILE_ATTRIBUTE_NORMAL);
	Source = CreateFile(File2Size,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
	size = GetFileSize(Source,NULL);
	if(size == HFILE_ERROR)return -1;
	CloseHandle(Source);
	return size;
}

///////////////////////////////////////////////////////////////////////

extern void ClearBuffer(void)
{
	int LocalLoop;
	LocalLoop = 0;
	while(LocalLoop < sizeof(Buffer))
	{
		Buffer[LocalLoop] = '\0';
		LocalLoop++;
	}
}

///////////////////////////////////////////////////////////////////////

extern DWORD WINAPI StatusDialog_Thread(LPVOID data)
{
	DialogBox(hInstance,MAKEINTRESOURCE(200),0,StatusDialog);
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI EncryptProcess_Thread(LPVOID data)
{
	EncryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI DecryptProcess_Thread(LPVOID data)
{
	DecryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI PackProcess_Thread(LPVOID data)
{
	PackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI UnpackProcess_Thread(LPVOID data)
{
	UnpackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern char *Get_Time()
{
	static SYSTEMTIME st;			   //SystemTime
	static char t [257];			   //SystemTime (Time)
	GetLocalTime(&st);
	GetTimeFormat(LOCALE_USER_DEFAULT,TIME_NOSECONDS,&st,NULL,t,64);
	return (t);
}

//////////////////////////////////////////////////////////////////////

extern char *Get_LongDate ()
{
	static SYSTEMTIME st;			   //SystemTime
	static char d [257];			   //SystemTime (LONG Date)
	GetLocalTime(&st);
	GetDateFormat(LOCALE_USER_DEFAULT,DATE_LONGDATE,&st,NULL,d,64);
	return (d);
}

//////////////////////////////////////////////////////////////////////

extern char *Get_UserName ()
{
	static char StrFunction [64][257];
	static int StrCnt;
	static char A[257];
	static DWORD b;
	if (++StrCnt==64) StrCnt = 0;
	b=256;
	GetUserName(A,&b);
	sprintf(StrFunction[StrCnt],"%s",A);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

/*
6	Check for read and write permission
4	Check for read permission
2	Check for write permission
1	Execute (ignored)
0	Check for existence of file
*/

extern BOOL FAccess(char *FileName, short Mode)
{
	if(access(FileName, Mode) == 0)
		return 1;
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern void Update_LastUsed(void)
{
	SetStringValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\LastRun","User",Get_UserName());
	SetStringValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\LastRun","Date",Get_LongDate());
	SetStringValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\LastRun","Time",Get_Time());
}

//////////////////////////////////////////////////////////////////////

