/*

 PackFiles.H - Pack Files Into One File Functions

extern int PackFiles(char *xTargetFile, char *Directory)
extern int WriteFiles(char *xTargetFile, short xPlaceHolder, char *FullFileString, char *Directory)

*/

///////////////////////////////////////////////////////////////////////

extern int PackFiles(char *xTargetFile, char *Directory)
{
	char File[20480];
	static OPENFILENAME ofn;

	int ReturnFlag;
	int Number_Of_Files = 0;

	ofn.lStructSize=sizeof(ofn);

	ofn.hwndOwner = StatusDialog_hWnd;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = File;
	ofn.nMaxFile = sizeof(File);
	ofn.lpstrInitialDir = Directory;
	ofn.Flags = OFN_ALLOWMULTISELECT + OFN_EXPLORER + OFN_LONGNAMES + OFN_FILEMUSTEXIST;
	ofn.lpstrTitle=TitleCaption;
	ReturnFlag = GetOpenFileName(&ofn);  // Open GetOpenFileName Dialog


	StatusDialog_Thread_Handle = CreateThread(NULL,0,StatusDialog_Thread,(LPVOID)0,0,&StatusDialog_Thread_ID);

	if(ReturnFlag == 0) // No Files Selected
	{
		Status = "No Files Selected...";
		unlink(xTargetFile);
		return 0;
	}

	Number_Of_Files = Get_NumberOfFiles(ofn.lpstrFile);

	if(Number_Of_Files == 0) // Only One File Selected
	{
		Status = "You Must Select More Than One File.";
		unlink(xTargetFile);
		return 0;
	}

	if(Number_Of_Files > 100) // Too Many Files Selected
	{
		Status = "You Cannot Select More Than 100 Files.";
		unlink(xTargetFile);
		return 0;
	}

	if(WriteFiles(xTargetFile,ofn.nFileOffset,ofn.lpstrFile,ofn.lpstrFile,Number_Of_Files))
	{
		return 1;
	}
	return 0;
}

///////////////////////////////////////////////////////////////////////

extern int WriteFiles(char *xTargetFile, short xPlaceHolder, char *FullFileString, char *Directory, int Number_Of_Files)
{
	int LocalFileCount = 0;
	int ClearLoop = 0;
	int PlaceHolder = 0;
	short SentSize = 0;

	char Local_Result[1024] = {'\0'};
	char FullFilePath[1024] = {'\0'};
	char Local_ScanTemp[7] = {'\0'};
	char StatusTemp[257] = {'\0'};

	DWORD SourceFileSize = 0;
	long double Current_Size = 0;

	FILE *LocalSource_File;
	FILE *LocalTarget_File;

	/* Open xTargetFile File */

	if((LocalTarget_File = fopen(xTargetFile,"wb")) == NULL)
	{
		if(LocalTarget_File)fclose(LocalTarget_File);
		unlink(xTargetFile);
		char ErrorTemp[1024];
		sprintf(ErrorTemp,"Could Not Open %s For Write. Error 19.",xTargetFile);
		Error(ErrorTemp);
		return 0;
	}

	{//Print Number Of Files (Begin)

		if(Number_Of_Files < 1000)
			fprintf(LocalTarget_File,"0");
		if(Number_Of_Files < 100)
			fprintf(LocalTarget_File,"0");
		if(Number_Of_Files < 10)
			fprintf(LocalTarget_File,"0");
		fprintf(LocalTarget_File,"%d|",Number_Of_Files);
	}//Print Number Of File (End)



	{//Print File Contents (Begin)

		PlaceHolder = xPlaceHolder;
		LocalFileCount = 0;

		while(LocalFileCount < Number_Of_Files)
		{
			LocalFileCount++;

			sprintf(StatusTemp,"Packing File %d of %d",LocalFileCount,Number_Of_Files);
			Status = StatusTemp;

			while(FullFileString[PlaceHolder] != '\0')
			{
				sprintf(Local_ScanTemp,"%c",FullFileString[PlaceHolder]);
				strcat(Local_Result,Local_ScanTemp);
				PlaceHolder++;
			}

			if(strlen(Directory) == 3)
			{
				sprintf(FullFilePath,"%s%s",Directory,Local_Result);
			}
			else
				{
				sprintf(FullFilePath,"%s\\%s",Directory,Local_Result);
			}

			{ // (Begin) Write File Size

				SourceFileSize = FileSize(FullFilePath);

				if(SourceFileSize > (1024 * 1024) * 75)
				{
					Status = "Files Must Be Under 75 MegaBytes.";
					if(LocalTarget_File)fclose(LocalTarget_File);
					unlink(xTargetFile);
					return 0;
				}

				if(SourceFileSize <= 0)
				{
					char ErrorTemp[1024];
					sprintf(ErrorTemp,"%s Contains No Data! \r\n Files Must Be Contain Some Data (At Least 1 Byte).",Local_Result);
					MessageBox(0, ErrorTemp , TitleCaption, 0 + MB_ICONASTERISK);
					if(LocalTarget_File)fclose(LocalTarget_File);
					unlink(xTargetFile);
					return 0;
				}

				if(SourceFileSize < 10000000)
					fprintf(LocalTarget_File,"0");
				if(SourceFileSize < 1000000)
					fprintf(LocalTarget_File,"0");
				if(SourceFileSize < 100000)
					fprintf(LocalTarget_File,"0");
				if(SourceFileSize < 10000)
					fprintf(LocalTarget_File,"0");
				if(SourceFileSize < 1000)
					fprintf(LocalTarget_File,"0");
				if(SourceFileSize < 100)
					fprintf(LocalTarget_File,"0");
				if(SourceFileSize < 10)
					fprintf(LocalTarget_File,"0");
				if(SourceFileSize < 1)
					fprintf(LocalTarget_File,"0");
				if(SourceFileSize != 0)
					fprintf(LocalTarget_File,"%d/",SourceFileSize);
			} // (End) Write File Size


			fprintf(LocalTarget_File,"%s/",Local_Result);

			Current_Size = 0;
			StatusValue = 0;

			SetFileAttributes(FullFilePath,FILE_ATTRIBUTE_NORMAL);
			if((LocalSource_File = fopen(FullFilePath,"rb")) == NULL)
			{
				char ErrorTemp[1024];
				if(LocalSource_File)fclose(LocalSource_File);
				if(LocalTarget_File)fclose(LocalTarget_File);
				unlink(xTargetFile);
				sprintf(ErrorTemp,"Could Not Open %s For Read. Error 20.",Local_Result);
				Error(ErrorTemp);
				return 0;
			}

			do
			{
				Buffer[0] = '\0';

				if(CancelFlag)
				{
					if(LocalSource_File)fclose(LocalSource_File);
					if(LocalTarget_File)fclose(LocalTarget_File);
					unlink(xTargetFile);
					CleanUp(0,1);
					return 0;
				}

				SentSize = fread(Buffer,sizeof(char),BufferSize,LocalSource_File);
				fwrite(Buffer,sizeof(char),SentSize,LocalTarget_File);
				Current_Size += SentSize;
				StatusValue = (Current_Size / SourceFileSize) *100;
			}
			while(SentSize == BufferSize);
			if(LocalSource_File)fclose(LocalSource_File);

			ClearLoop = 0;
			while(ClearLoop < sizeof(Local_Result)) // Clear ( Local_Result )
			{
				Local_Result[ClearLoop] = '\0';
				ClearLoop++;
			}
			ClearLoop = 0;
			while(ClearLoop < sizeof(Local_ScanTemp)) // Clear ( Local_ScanTemp )
			{
				Local_ScanTemp[ClearLoop] = '\0';
				ClearLoop++;
			}

			PlaceHolder++;
			if(FullFileString[PlaceHolder] == '\0')break;
		}
	}//Print File Contents (End)


	if(LocalSource_File)fclose(LocalSource_File);
	if(LocalTarget_File)fclose(LocalTarget_File);

	return 1;
}

///////////////////////////////////////////////////////////////////////


