/*
 UnPackFiles.H - Functions Used To Unpack Files From A Single File

extern int UnPackFiles(char *SourceFileName, char *Directory)

*/

////////////////////////////////////////////////////////////////////////

extern int UnPackFiles(char *SourceFileName, char *Directory)
{
	FILE *Source_File;
	FILE *Target_File;

	int LocalLoop = 0;
	int FileSizeLeft = 0;
	int LocalFileCount = 0;
	int Number_Of_Files = 0;

	char FileName[257];
	char CharBuffer = '\0';
	char FullFileName[257];
	char StatusTemp[257];

	DWORD SourceFileSize = 0;
	long double Current_Size = 0;

	Buffer[0] = '\0';

	/* Open Source File */
	if((Source_File = fopen(SourceFileName,"rb")) == NULL)
	{
		char ErrorTemp[1024];
		sprintf(ErrorTemp,"Could Not Open %s For Read. Error 21.",SourceFileName);
		Error(ErrorTemp);
		return 0;
	}
	fseek(Source_File,0,SEEK_SET);

	// ------------------------------------------
	{ // (Begin) Get Number Of Files
		ClearBuffer();
		fread(Buffer,sizeof(char),4,Source_File);
		Number_Of_Files = CharInt(Buffer);
		fseek(Source_File,1,SEEK_CUR);
	} // (End) Get Number Of Files


	while(LocalFileCount < Number_Of_Files)
	{
		// ------------------------------------------

		LocalFileCount++;
		sprintf(StatusTemp,"Unpacking File %d of %d",LocalFileCount,Number_Of_Files);
		Status = StatusTemp;

		// ------------------------------------------

		{ // (Begin) Get SourceFileSize

			ClearBuffer();
			fread(Buffer,sizeof(char),8,Source_File);
			SourceFileSize = CharInt(Buffer);
			fseek(Source_File,1,SEEK_CUR);
		} // (End) Get SourceFileSize


		// ------------------------------------------

		{ // (Begin) Get FileName

			LocalLoop = 0;
			FileName[0] = '\0';
			while(LocalLoop < 257)
			{
				LocalLoop++;
				CharBuffer = '\0';
				fscanf(Source_File, "%c", &CharBuffer);
				if(strcmp("/",&CharBuffer) == 0) break;
				strcat(FileName,&CharBuffer);
			}
		} // (End) Get FileName


		// ------------------------------------------


		{ // (Begin) Open And Write File

			sprintf(FullFileName,"%s\\%s",Directory,FileName);
			if((Target_File = fopen(FullFileName,"wb")) == NULL)
			{
				char ErrorTemp[1024];
				sprintf(ErrorTemp,"Could Not Open %s For Write. Error 22.",FullFileName);
				Error(ErrorTemp);
				return 0;
			}

			ClearBuffer();
			Current_Size = 0;
			StatusValue = 0;

				Current_Size = 0;
				while(Current_Size <= SourceFileSize)
				{
					FileSizeLeft = (SourceFileSize - Current_Size);
					if(FileSizeLeft <= BufferSize)
					{
						if(CancelFlag)
						{
							if(Source_File)fclose(Source_File);
							if(Target_File)fclose(Target_File);
							unlink(FullFileName);
							CleanUp(0,1);
							return 0;
						}
						ClearBuffer();
						fread(Buffer,sizeof(char),FileSizeLeft,Source_File);
						fwrite(Buffer,sizeof(char),FileSizeLeft,Target_File);
						Current_Size = Current_Size + FileSizeLeft;
						StatusValue = (Current_Size / SourceFileSize) *100;
						break;
					}

					StatusValue = (Current_Size / SourceFileSize) *100;
					Current_Size += BufferSize;
					fread(Buffer,sizeof(char),BufferSize,Source_File);
					fwrite(Buffer,sizeof(char),BufferSize,Target_File);
				}
				if(Current_Size != SourceFileSize)
				{
					char ErrorTemp[1024];
					sprintf(ErrorTemp,"File Compare Error. Error 23.\n",FileName);
					Error(ErrorTemp);
					return 0;
				}

			if(Target_File) fclose(Target_File);
		} // (End) Open And Write File


		// ------------------------------------------
	}

	if(Source_File)fclose(Source_File);
	if(Target_File)fclose(Target_File);

	return 1;
}

////////////////////////////////////////////////////////////////////////

